import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import Header;

class MessageDialog extends Dialog implements ActionListener
{
	public MessageDialog(Frame parent, String title, String error) {
		super(parent, title, true);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);
		c.gridy = 0;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Label l = new Label(error);
		gridbag.setConstraints(l, c);
		add(l);
		c.gridy = GridBagConstraints.RELATIVE;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Button b =  new Button("Ok");
		b.addActionListener(this);
		gridbag.setConstraints(b, c);
		add(b);
		setResizable(false);
		setBounds(40, 70, 240, 150);
	}
	
	public void actionPerformed(ActionEvent e) {
		String arg = e.getActionCommand();
		if (arg.equals("Ok")) {
			dispose();
		}
	}
}

class appFrame extends Frame implements ActionListener, WindowListener
{
  Header hdr;

  public appFrame() {
    super("Header Test");
    addWindowListener(this);
    setLayout(new BorderLayout());
    setBounds(30, 40, 500, 300);
    hdr = new Header(3);
    hdr.addActionListener(this);
    hdr.addHeadItem("Header 1");
    hdr.addHeadItem("Header 2");
    hdr.addHeadItem("Header 3");
    add("Center", hdr);
    doLayout();
    show();
  }

  public void actionPerformed(ActionEvent e) {
    String name = e.getActionCommand();
    String title = new String("Action");
    if (e.getModifiers() == ActionEvent.ACTION_LAST + 1)
      title = new String("Drag Action");
    else if (e.getModifiers() == ActionEvent.ACTION_LAST + 2)
      title = new String("Click Action");
    MessageDialog eDlg = new MessageDialog(this, title, name);
    eDlg.setBounds(50, 70, 240, 150);
    eDlg.show();
  }

  public void windowActivated(WindowEvent e) {} 
  public void windowClosed(WindowEvent e) {} 
  public void windowClosing(WindowEvent e) { System.exit(0); } 
  public void windowDeactivated(WindowEvent e) {} 
  public void windowDeiconified(WindowEvent e) {} 
  public void windowIconified(WindowEvent e) {} 
  public void windowOpened(WindowEvent e) {} 
}

public class HeaderTest extends Applet {
  public void init() {
    new appFrame();
  }
	
  public static void main(String args[]) {
    Frame f = new Frame("HeaderTest");
    HeaderTest app = new HeaderTest();

    app.init();
    app.start();
    f.add("Center", app);
  }
}
