import java.awt.*;
import java.awt.event.*;
import java.applet.Applet;
import java.lang.Long;
import java.util.Date;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import ToolButton;
import ToolBar;
import ListView;

class AboutDialog extends Dialog implements ActionListener
{
	public AboutDialog(Frame parent, String title) {
		super(parent, title, true);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);
		c.gridy = 0;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Label l1 = new Label("Voyager");
		gridbag.setConstraints(l1, c);
		add(l1);
		c.gridy = GridBagConstraints.RELATIVE;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Label l2 = new Label("Copyright(C) 1997 IS Corp.");
		gridbag.setConstraints(l2, c);
		add(l2);
		c.gridy = GridBagConstraints.RELATIVE;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Button b =  new Button("Ok");
		b.addActionListener(this);
		gridbag.setConstraints(b, c);
		add(b);
		setResizable(false);
	}
	
	public void actionPerformed(ActionEvent e) {
		String arg = e.getActionCommand();
		if (arg.equals("Ok")) {
			dispose();
		}
	}
}

class MessageDialog extends Dialog implements ActionListener
{
	public MessageDialog(Frame parent, String title, String error) {
		super(parent, title, true);
		GridBagLayout gridbag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridbag);
		c.gridy = 0;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Label l = new Label(error);
		gridbag.setConstraints(l, c);
		add(l);
		c.gridy = GridBagConstraints.RELATIVE;
		c.gridx = 0;
		c.weighty = 1.0;
		c.weightx = GridBagConstraints.REMAINDER;
		c.anchor = GridBagConstraints.CENTER;
		Button b =  new Button("Ok");
		b.addActionListener(this);
		gridbag.setConstraints(b, c);
		add(b);
		setResizable(false);
		setBounds(40, 70, 240, 150);
	}
	
	public void actionPerformed(ActionEvent e) {
		String arg = e.getActionCommand();
		if (arg.equals("Ok")) {
			dispose();
		}
	}
}

class appFrame extends Frame implements ActionListener, MouseListener,
                                        WindowListener, ComponentListener
{
  ListView lv;
  int vmode = ListView.ICONVIEW;
  PopupMenu pm;
  Menu fileMenu, editMenu, searchMenu, viewMenu, runMenu, helpMenu;
  MenuItem mi, fup, fdown, fdelete, fexit, 
           eundo, ecut, ecopy, epaste, 
           sfind, vicon, vdetail, rrun, habout;
  MenuBar mb; 
  ToolBar tb;
  File path = new File("//");

  public appFrame() {
    super("Voyager");
    addWindowListener(this);
    addMouseListener(this);
    mb = new MenuBar();
    fileMenu = new Menu("File");
    fup = fileMenu.add(new MenuItem("Up"));
    fup.addActionListener(this);
    fdown = fileMenu.add(new MenuItem("Down"));
    fdown.addActionListener(this);
    mi = fileMenu.add(new MenuItem("Rename"));
    mi.addActionListener(this);
    fdelete = fileMenu.add(new MenuItem("Delete"));
    fdelete.addActionListener(this);
    fileMenu.addSeparator();
    fexit = fileMenu.add(new MenuItem("Exit"));
    fexit.addActionListener(this);
    mb.add(fileMenu);
    editMenu = new Menu("Edit");
    eundo = editMenu.add(new MenuItem("Undo"));
    eundo.addActionListener(this);
    editMenu.addSeparator();
    ecut = editMenu.add(new MenuItem("Cut"));
    ecut.addActionListener(this);
    ecopy = editMenu.add(new MenuItem("Copy"));
    ecopy.addActionListener(this);
    epaste = editMenu.add(new MenuItem("Paste"));
    epaste.addActionListener(this);
    editMenu.addSeparator();
    mi = editMenu.add(new MenuItem("Select All"));
    mi.addActionListener(this);
    mb.add(editMenu);
    searchMenu = new Menu("Search");
    sfind = searchMenu.add(new MenuItem("Find File"));
    sfind.addActionListener(this);
    mb.add(searchMenu);
    viewMenu = new Menu("View");
    mi = viewMenu.add(new MenuItem("Toolbar"));
    mi.addActionListener(this);
    viewMenu.addSeparator();
    vicon = viewMenu.add(new MenuItem("List"));
    vicon.addActionListener(this);
    vdetail = viewMenu.add(new MenuItem("Details"));
    vdetail.addActionListener(this);
    mb.add(viewMenu);
    runMenu = new Menu("Run");
    rrun = runMenu.add(new MenuItem("Run"));
    rrun.addActionListener(this);
    mb.add(runMenu);
    helpMenu = new Menu("Help");
    habout = helpMenu.add(new MenuItem("About"));
    habout.addActionListener(this);
    mb.add(helpMenu);
    setMenuBar(mb);
    pm = new PopupMenu();
    mi = pm.add(new MenuItem("Rename"));
    mi.addActionListener(this);
    mi = pm.add(new MenuItem("Delete"));
    mi.addActionListener(this);
    pm.addSeparator();
    mi = pm.add(new MenuItem("Cut"));
    mi.addActionListener(this);
    mi = pm.add(new MenuItem("Copy"));
    mi.addActionListener(this);
    pm.addSeparator();
    mi = pm.add(new MenuItem("Paste"));
    mi.addActionListener(this);
    add(pm);
    setLayout(new BorderLayout());
    setBounds(30, 40, 500, 300);
    tb = new ToolBar();
    tb.addActionListener(this);
    tb.addButton(fup, "up.gif");
//    tb.addButton(fdown, "down.gif");
    tb.addSeparator();
    tb.addButton(ecut, "cut.gif");
    tb.addButton(ecopy, "copy.gif");
    tb.addButton(epaste, "paste.gif");
    tb.addButton(eundo, "undo.gif");
    tb.addSeparator();
    tb.addButton(sfind, "find.gif");
    tb.addButton(fdelete, "delete.gif");
    tb.addSeparator();
    tb.addButton(vicon, "iconview.gif");
    tb.addButton(vdetail, "detailview.gif");
    tb.addSeparator();
    tb.addButton(habout, "help.gif");
    tb.addButton(fexit, "exit.gif");
    add("North", tb);
    lv = new ListView(3);
    lv.addActionListener(this);
    add("Center", lv);
    lv.addColumnHeader("Name", 0);
    lv.addColumnHeader("Size", 1);
    lv.addColumnHeader("Modified", 2);
    loadDirectory(path, lv);
    doLayout();
    show();
  }
	
  public void loadDirectory(File path, ListView lv) {
    ListItem li;
    File file;
    String[] files = path.list();

    for (int i = 0; i < files.length; i++) {
      file = new File(path, files[i]);
      if (file.isDirectory()) {
        li = lv.addListItem("dir.gif", file.getName());
        li.addItemDetail(file.getName());
        li.addItemDetail("");
        li.addItemDetail("");
      } else {
        li = lv.addListItem("file.gif", file.getName());
        li.addItemDetail(file.getName());
        Long len = new Long(file.length());
        li.addItemDetail(len.toString());
        Date d = new Date(file.lastModified());
        li.addItemDetail(d.toString());
      }
    }
  }

  public void mouseClicked(MouseEvent e) {
    System.err.print(e.toString() + "\n");
    if ((e.getModifiers() & MouseEvent.BUTTON2_MASK) == 1)
      pm.show(this, e.getX(), e.getY());
  }
  public void mousePressed(MouseEvent e) {}
  public void mouseReleased(MouseEvent e) {}
  public void mouseEntered(MouseEvent e) {}
  public void mouseExited(MouseEvent e) {}

  public void actionPerformed(ActionEvent e) {
    if (e.getSource() instanceof ListPanel) {
      String name = e.getActionCommand();
      File newpath = new File(path, name);
      if (newpath.isDirectory()) {
        path = newpath;
        lv.Clear();
        loadDirectory(path, lv);
        lv.resetView();
      }
    } else if ((((MenuItem)e.getSource()).getParent() instanceof Menu) ||
            (((MenuItem)e.getSource()).getParent() instanceof PopupMenu)) {
      String label = e.getActionCommand();
        if (label.equals("Exit")) {
          System.exit(0);
        } else if (label.equals("Up")) {
          if (path.getParent() != null) {
            path = new File(path.getParent());
            lv.Clear();
            loadDirectory(path, lv);
            lv.resetView();
          }
        } else if (label.equals("List")) {
          vmode = ListView.ICONVIEW;
          lv.setViewMode(vmode);
        } else if (label.equals("Details")) {
          vmode = ListView.DETAILVIEW;
          lv.setViewMode(vmode);
        } else if (label.equals("About")) {
          AboutDialog aDlg = new AboutDialog(this, "About");
          aDlg.setBounds(50, 70, 240, 150);
          aDlg.show();
        } else if (label.equals("Delete")) {
          MessageDialog eDlg = new MessageDialog(this, "Delete", "Are You Sure ?");
          eDlg.setBounds(50, 70, 240, 150);
          eDlg.show();
        } else if (label.equals("Rename")) {
          MessageDialog eDlg = new MessageDialog(this, "Rename", "Ok !");
          eDlg.setBounds(50, 70, 240, 150);
          eDlg.show();
        } 
    }
  }

  public void windowActivated(WindowEvent e) {} 
  public void windowClosed(WindowEvent e) {} 
  public void windowClosing(WindowEvent e) { System.exit(0); } 
  public void windowDeactivated(WindowEvent e) {} 
  public void windowDeiconified(WindowEvent e) {} 
  public void windowIconified(WindowEvent e) {} 
  public void windowOpened(WindowEvent e) {} 

  public void componentHidden(ComponentEvent e) {}
  public void componentMoved(ComponentEvent e) {} 
  public void componentResized(ComponentEvent e) { 
    System.out.println("Frame Resized !");
  } 
  public void componentShown(ComponentEvent e) {}
}

public class Voyager extends Applet {
  public void init() {
    new appFrame();
  }
	
  public static void main(String args[]) {
    Frame f = new Frame("Voyager");
    Voyager app = new Voyager();

    app.init();
    app.start();
    f.add("Center", app);
  }
}
